// $Id: WILL_HtmlConversion.js,v 1.9 2006/01/11 13:50:39 Will Exp $

//WILL: TODO: this isn't very OOP! The funcs with double __ should be private members

var NODE_START_CHAR  = '\v'; //vertical-tab - counts as whitespace
var ELEM_END_CHAR    = '\f'; //form-feed WILL: We assume no vertical-tabs or form-feeds in the HTML. WILL: TODO: add check
var ELEM_END_CHAR_RE = /\f/g; // for globally removing the end chars

// function WILL_getHtmlTag(docObj) {
//   var list=docObj.getElementsByTagName('HTML');
//   if (!list || !list.length ) { WILL_log('WARN','no HTML tag in '+docObj.URL); return null; }
//   if (list.length != 1) { WILL_log('WARN','more than one HTML tag in '+docObj.URL); return null; }
//   var htmlTag = list[0];
//   if (htmlTag.nodeName != 'HTML') { WILL_log('WARN','html tag was not HTML?? in '+docObj.URL); return null; }
//   return htmlTag;
// }

// function WILL_writeDocStore(docObj,text) {

//   var html=WILL_getHtmlTag(docObj);
//   if (!html) { return; }
//   html.setAttribute('VMC_original_content',text);
// }

// function WILL_readDocStore(docObj) {
//   var html=WILL_getHtmlTag(docObj);
//   if (!html) {return undefined;}
//   if (!html.getAttribute) {WILL_log('WARN','Missing getAttribute! on '+docObj.URL); return null;}
//   return html.getAttribute('VMC_original_content');
// }

function HtmlConversion_isURLtoAvoid(url) {
  var avoid=false;
  if (/jsunit/.test(url)) {
    avoid=true;
  }
  if (avoid) { WILL_log('INFO','Avoiding: '+url); }
  return avoid;
}

function HtmlConversion_restorePage(docObj) {
  WILL_log('INFO','Restoring page: '+docObj.URL);

  if (HtmlConversion_isURLtoAvoid(docObj.URL)) {
    return; //don't modify the JsUnit pages. WILL: TODO: come up with a more elegant way of testing
  }

  var range = { startContainer:docObj.body, endContainer:docObj.body };
    
  var nodes   = HtmlConversion__getAllNodesInRange(range);

  //D: WILL_log('INFO','WILL_originalText for URL:'+docObj.URL+'\n EQUALS:'+WILL_shortenStr(WILL_readDocStore(docObj),40) );

//   if (!WILL_readDocStore(docObj)) {
//      WILL_log('INFO','Tried to restore page without original text available - if it had not been changed this is not a problem');
//     return;
//   }
//  HtmlConversion__setTextOfNodes(nodes,WILL_readDocStore(docObj));

  var oldText = HtmlConversion__getTextOfNodes(nodes);
  HtmlConversion__setTextOfNodes(nodes,oldText);

  return; //WILL: the older system follows:
}
//     var allElements;
//     var thisElement;
//     allElements = docObj.getElementsByTagName('*');
//     var node;
//     var i,c;

//     for (i = 0; i < allElements.length; i++) {
//       thisElement = allElements[i];
//       for (c = 0; c < thisElement.childNodes.length; c++) {
// 	node=thisElement.childNodes[c];
// 	if (node.nodeType == 3)
// 	  if (node.WILL_originalNodeValue)
// 	    node.nodeValue=node.WILL_originalNodeValue;
//       }
//     }
//   }
    
	
////////////////////////////////
function HtmlConversion_changePageToTargetCurrencyUsingNodes(docObj,targetCurrency, hideOriginal, sourceCurrencyList, getRateFunc) {
  ///////////////////////////////
  WILL_log('INFO','Changing page: '+docObj.URL);
  if (HtmlConversion_isURLtoAvoid(docObj.URL)) {
    return; //don't modify the JsUnit pages. WILL: TODO: come up with a more elegant way of testing
  }

  var range = { startContainer:docObj.body, endContainer:docObj.body };
  var nodes   = HtmlConversion__getAllNodesInRange(range);

  
  //D: WILL_log('INFO','WILL_originalText for URL:'+docObj.URL+
  //D:          '\n EQUALS: '+WILL_shortenStr(WILL_readDocStore(docObj),40) );
      
  var oldText;
//   if (WILL_readDocStore(docObj)) {
//     oldText = WILL_readDocStore(docObj);
//   } else {
    oldText = HtmlConversion__getTextOfNodes(nodes);
//  }
    
  WILL_log('DBG3','Original number of nodes = '+nodes.length);
  WILL_log('DBG3','Original node length = '+oldText.split(NODE_START_CHAR).length+' content = '+oldText);

  var newText =  WILL_CurrencyConvertStr(oldText,targetCurrency, sourceCurrencyList, getRateFunc, hideOriginal);

  if (!newText) {
    WILL_log('INFO','No changes to make');
    return; //nothing to do
  }
    
  WILL_log('DBG3','New node length = '+newText.split(NODE_START_CHAR).length+' new content = '+newText);

  HtmlConversion__setTextOfNodes(nodes,newText);

  //  WILL_writeDocStore(docObj,oldText);
  //D: WILL_log('INFO','Set WILL_originalText for URL:'+docObj.URL+
  //D:	   '\n TO    : '+WILL_shortenStr(oldText,40)+
  //D:	   '\n ACTUAL: '+WILL_shortenStr(WILL_readDocStore(docObj),40) );
    
  return; //WILL: TODO: compare with old system - which is faster ?
}
//WILL: TODO: We could do an auto-detect based on docObj.body.textContent.match(compeleteList.eitherCurrencyRegexp)
//     //WILL: process text boxes ??
//     //     var inputElements = docObj.getElementsByTagName('input');
//     //     for (i=0; i<inputElements.length; i++) {
//     //       thisElement=inputElements[i];
//     //       thisElement.value=thisElement.value.replace(/t/g,'Mr T');
//     //     }

//     var allElements;
//     var thisElement;
//     allElements = docObj.getElementsByTagName('*');
//     var node;
//     var i,c;

    
//     var newValue;
//     var leftRegExp=this.sourceCurrencyList.getCurrencyLeftRegExp();
//     var rightRegExp=this.sourceCurrencyList.getCurrencyRightRegExp();
    
//     for (i = 0; i < allElements.length; i++) {
//       thisElement = allElements[i];
//       for (c = 0; c < thisElement.childNodes.length; c++) {
// 	node=thisElement.childNodes[c];
// 	if (node.nodeType == 3) {
// 	  if (!node.WILL_originalNodeValue) node.WILL_originalNodeValue=node.nodeValue; //store the original value
// 	  //always work with the original value - stops endless ((()))
// 	  //wrap my convert method in an annoymous function because Javascript Inner Functions set 'this' to the global object!

// 	  newValue=node.WILL_originalNodeValue.replace(leftRegExp,
// 						       function(match,boundary,curr,num) {return self.convertCurrency(match,curr,num,boundary,LEFT)} );
// 	  newValue=newValue.replace(rightRegExp,       function(match,num,curr,boundary) {return self.convertCurrency(match,curr,num,boundary,RIGHT)} );
// 	  node.nodeValue=newValue;
// 	}
//       }
//     }
    

//   }

function HtmlConversion__changeNodesInRange(range,targetCurrency,hideOriginal) {

  var endOffset   = range.endOffset;
  var startOffset = range.startOffset;

  //WILL_testInsert(range);

  var nodes   = HtmlConversion__getAllNodesInRange(range);
  var text    = HtmlConversion__getTextOfNodes(nodes,startOffset,endOffset);

  var newText = WILL_CurrencyConvertStr(oldText,targetCurrency, this.sourceCurrencyList, this.exchangeRateCache.getRate, hideOriginal);

  if (!newText) { return; } //nothing to do
    
  HtmlConversion__setTextOfNodes(nodes,newText,startOffset,endOffset);
}


//WILL: should this be private - used by PopupToolbar
// if offsets are undefined, then take use complete start and end node values
// Will first return the original value of the node if we set that while making changes. Otherwise return current value in DOM
// (if somebody else has edited a node that we had converted, their change will be lost)
// NOTE: this is not the same as node.textContent as getNodes() above has weeded out SCRIPT nodes.
function HtmlConversion__getTextOfNodes(nodes,startOffset,endOffset) {
  var text='';
  var str;
  var i;
  var EMPTY='';
  if (!nodes.length) {WILL_log('WARN','no text nodes in range'); return null; }

  if (nodes.length==1) {
    //  ************ single node range ***************
    // first node:
    str=nodes[0].oldValue || nodes[0].nodeValue || EMPTY;
    if (startOffset===undefined)  { text += str; }
    else                          { text += str.substr(startOffset,endOffset-startOffset); }

  } else {

    //  *************** multiple nodes ****************
    // first node:
    str=nodes[0].oldValue || nodes[0].nodeValue || EMPTY;
    if (startOffset===undefined) { text += str; }
    else                         { text += str.substr(startOffset,str.length-startOffset); } // rightStr
    for (i=1; i < nodes.length-1 ; i++) {
      // middle nodes:
      text += NODE_START_CHAR + (nodes[i].oldValue || nodes[i].nodeValue || EMPTY);
      if (nodes[i].nextSibling === null ) { text += ELEM_END_CHAR; } // we have reached the last child of the current element
    }
    // last node:
    str=nodes[i].oldValue || nodes[i].nodeValue || EMPTY;
    if (endOffset===undefined)  { text += NODE_START_CHAR + str; }
    else                        { text += NODE_START_CHAR + str.substr(0,endOffset); } // leftStr
 
  } 
    
  return text;
}
    


function HtmlConversion__diffTextOfNodes(nodes,newText) {
  var str;
  var newValue;
  var oldValue;
  var i;
  newText = newText.replace(ELEM_END_CHAR_RE,''); //remove the element end markers - they are only used for giving the correct string lengths when calculting which number is closest to which currency symbol
  var newNodesContent=newText.split(NODE_START_CHAR);

  //  *************** multiple nodes ****************
  // we check only the
  // middle nodes:
    for (i=1; i < nodes.length-1 ; i++) {  
      newValue=newNodesContent[i] || ''; //convert null to ''  WILL: TODO: how can this be null too?
      oldValue=nodes[i].nodeValue || ''; //convert null to ''
      if (newValue != oldValue) {
	dump('nodes['+i+'] diff: '+
	     'NEW: ['+WILL_shortenStr(newValue,60)+']   '+
	     'OLD: ['+WILL_shortenStr(oldValue,60)+']\n');
      }
    }
    //TODO: look at DOMSubTreeModified mutation event
}



      
      
// I tried to use attributes to store the original values but Text nodes don't have attributes. And there can be more than one text node per parent node so I just just store it in the parent.
function HtmlConversion__changeNode(node,newValue) {
  var attr;
  var store;
  var oldValue=node.nodeValue;
  if (oldValue != newValue) {
    //dump('changing node from ['+WILL_shortenStr(oldValue,30)+'] to ['+WILL_shortenStr(newValue,30)+']\n');
    node.nodeValue=newValue;

    if (node.oldValue) {
      //we only allow resetting to the original value, not undoing the last conversion
      //dump('WILL: not changing oldValue as it was already set to '+WILL_shortenStr(node.oldValue,30)+'\n\n');
    } else {
      node.oldValue=oldValue; //record the change
    }
  }
}
function HtmlConversion__setTextOfNodes(nodes,newText,startOffset,endOffset, forceUpdateEmpty) {
  var str;
  var newValue;
  var leftStr;
  var rightStr;
  var i;
  newText = newText.replace(ELEM_END_CHAR_RE,''); //remove the element end markers - they are only used for giving the correct string lengths when calculting which number is closest to which currency symbol
  var newNodesContent=newText.split(NODE_START_CHAR);
  if (newNodesContent.length != nodes.length) {
    WILL_log('ERR',' We have new content for '+newNodesContent.length+' nodes but there are '+nodes.length+' nodes to fill!');
    HtmlConversion__diffTextOfNodes(nodes,newText);
  }

  //WILL_log('WARN',nodes.join(','));
  //HtmlConversion__setNodesInRange(range,newNodeContent);

  if (nodes.length==1) {
    //  ************ single node range ***************
    // first node:
    newValue=newNodesContent[0];
    str=nodes[0].nodeValue;
    if (newValue ||  forceUpdateEmpty) {
      if (startOffset===undefined) {
	HtmlConversion__changeNode(nodes[0],newValue);
      } else {
	leftStr  = str.substr(0,startOffset);
	rightStr = str.substr(endOffset,str.length-endOffset);
	HtmlConversion__changeNode(nodes[0], leftStr + newValue + rightStr);
      }
    }
  } else {
    //  *************** multiple nodes ****************
    // first node:
    newValue=newNodesContent[0];
    if (newValue  ||  forceUpdateEmpty) {
      if (startOffset===undefined) {
	HtmlConversion__changeNode(nodes[0],newValue);
      } else {
	str=nodes[0].nodeValue;
	HtmlConversion__changeNode(nodes[0], str.substr(0,startOffset) + newValue); // leftStr
      }
    }
    // middle nodes:
    for (i=1; i < nodes.length-1 ; i++) {  
      newValue=newNodesContent[i];
      if (newValue  ||  forceUpdateEmpty) {
	HtmlConversion__changeNode(nodes[i],newValue);
      }
    }
    // last node:
    newValue=newNodesContent[i];
    if (newValue  ||  forceUpdateEmpty) {
      if (endOffset===undefined) {
	HtmlConversion__changeNode(nodes[i],newValue);
      } else {
	str=nodes[i].nodeValue;
	HtmlConversion__changeNode(nodes[i], newValue + str.substr(endOffset,str.length-endOffset)); // rightStr
      }
    }
  }
  //WILL: TODO: if (newValue && newValue != old)   + store old value!
  //WILL: TODO: help the GC
}



      
      
//WILL: TODO: should this be private? It's used by PopupConvertToolbarManager
function HtmlConversion__getAllNodesInRange(range) {
  var endNode     = range.endContainer;
  var startNode   = range.startContainer;

  if (startNode==endNode && !startNode.firstChild) { return [startNode]; } // blank page or single node selected

  var textNodes=[];
  var currentNode=startNode;
  /* if (currentNode.nodeType == 3) */ textNodes.push(currentNode);

 walktree:
  while (currentNode) {
    if (currentNode.firstChild && currentNode.nodeName != "SCRIPT") {
      currentNode=currentNode.firstChild;
    } else {
      while (!currentNode.nextSibling) {
	currentNode=currentNode.parentNode;
	if (currentNode == endNode) { break walktree; }
      }
      currentNode=currentNode.nextSibling;
    }
      
    // Add the text node to the list:
    /* if (currentNode.nodeType == 3) */
    textNodes.push(currentNode);
    if (!currentNode) {WILL_alert('null node'); break walktree; }

    //WILL: TODO: If I want to check for marker chars in the original HTML then enable this: (it's slow!)
//     if (currentNode.nodeValue) {
//       var text=currentNode.nodeValue;
//       if (HtmlConversion_countMarkerChars(text)) {
// 	dump('ERROR: Marker found in '+WILL_shortenStr(text,40)+'\n');
//       }
//     }

    if (currentNode == endNode) { break walktree; }
  } //end while

  if (!currentNode) {WILL_alert('got a null current node');}
  return textNodes;
}

function HtmlConversion_countMarkerChars(text) {
  var markers=0;
  for (var i=0;i<text.length;i++) {
    if (text[i]==NODE_START_CHAR || text[i]==ELEM_END_CHAR) {
      markers++;
    }
  }
  return markers;
}

