// $Id: WILL_StartUpDialogManager.js,v 1.6 2006/01/04 19:59:23 Will Exp $');

var WILL_startupManager;

function WILL_StartUpDialogLoad() {
  if (!window.arguments) { WILL_alert('this window cannot be opened without a completeList, a defaultSourceList and a return val'); }
  WILL_startupManager = new WILL_StartUpDialogManager(window.arguments[0],window.arguments[1],window.arguments[2]);
}


// this works without seeing the main ViewMyCurrency object - it just gets/sets the prefs
// this requires ViewMyCurrency to use watchers to detect and act on the changes
// Advantages: PrefManager doesn't depend on ViewMyCurrency
//             Prefs can be safely edited in about:config 
//             Everything stays in sync if a new application window is started (with Control-N for example)
function WILL_StartUpDialogManager(completeList,defaultSourceList,returnVal) {

  this._completeList=completeList;
  this._defaultSourceList=defaultSourceList;
  this._returnVal=returnVal;

  this.updateSelectPage  = updateSelectPage
  this.updateFinalPage   = updateFinalPage; 
  this.doFinish          = doFinish;
  this.doCancel          = doCancel;
  
  this.initCurrencyList = initCurrencyList;
  
  this._listBox = null; // Pointer to the currencyListBox

  function initCurrencyList() {
    if (!this._listBox) {
      this._listBox = WILL_ge('WILL_SelectedListBox');
      this._listBox.init(this._completeList);
      this.updateSelectPage();
    }
  }

  function updateSelectPage() {
    var currencyList=this._listBox.getSelectedCurrencies();
    if (currencyList.length) {
      WILL_ge('WILL-firstrun-wizard').canAdvance=true;
    } else {
      WILL_ge('WILL-firstrun-wizard').canAdvance=false;
    }
  }

  function doCancel() {
    //alert('WILL: should I warn and say how to do a config later?');
    return true; //let the cancel complete
  }

  function doFinish() {
    var currencyList=this._listBox.getSelectedCurrencies();
    if (!currencyList.length) { WILL_alert('no selected currencies'); }

    this._returnVal['newTargetCurrency']=currencyList;
    return true; // let the Finish happen
  }

  function updateFinalPage() {
    var targetText = this._listBox.getSelectedCurrencies()[0].toString(false);
    var sourceListItems = this._defaultSourceList.items;
    var sourceListbox = WILL_ge('WILL-sourceCurrency-list');

    WILL_killChildren(sourceListbox);
    
    var label;
    var text;
    for (var i=0; i<sourceListItems.length; i++) {
      label=document.createElement('label');
      text=sourceListItems[i].toString(false); //add verbose human readble name of currency
      label.setAttribute('value',text);
      sourceListbox.appendChild(label);     
    }


    WILL_ge('WILL-targetCurrency-label').value=targetText;

    
  }
}

