// $Id: WILL_CurrencyListBox.js,v 1.6 2006/01/06 11:35:51 Will Exp $

// WILL: ?? because of the inferface this implements I cannot use additional properities from outside the object
function WILL_TreeView(aList,highlightDups) {
  var aserv=Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
  this.list=aList;
  this.highlightDups=highlightDups;
  this.rowCount = this.list.items.length;
  //WILL: TODO: Support column object for Firefox 1.1
  this._symbolCol = function(colName) {
    var symbolscol="symbolscol";
    if (colName.substr(0,symbolscol.length) == symbolscol) {
      var digit=colName[symbolscol.length]; //return the final digit in symbolscol0, col1 etc
      return digit;
    }
    return -1;
  };
  this._col2symbol = function(colName,curr) {
    var digit=this._symbolCol(colName);
    if (digit<0) { return null; }
    if (digit>=curr.symbols.length) { return ' '; }
    return curr.symbols[digit];
  };
  this.getCellText = function(row,colObj){
    if (row<0 || row>=this.list.items.length) { return null; } //WILL: log?
    var colName=WILL_toColName(colObj);
    var digit,symbol;
    var curr=this.list.items[row];
    if      (colName == "countrycol")                   { return curr.country;              }
    else if (colName == "descriptioncol")               { return curr.description;          }
    else if (colName == "codecol")                      { return curr.code;                 }
    else if (colName == "dspIndexcol")                  { return curr.displaySymbolIndex;   }
    else if ( (symbol=this._col2symbol(colName,curr)) ) { return symbol;                    }
    else                                               { return "????";                    }
  };
  this.setTree = function(treebox){ this.treebox = treebox; };
  this.isEditable = function(index, colObj) { alert('h'); return false; };
  this.isContainer = function(row){ return false; };
  this.isSeparator = function(row){ return false; };
  this.isSorted = function(row){ return false; };
  this.getLevel = function(row){ return 0; };
  this.getImageSrc = function(row,col){ return null; };
  this.getRowProperties = function(row,props){};
  //this.getCellProperties = function(row,col,props) {};
  this.getCellProperties = function(row,colObj,props){
    var colName=WILL_toColName(colObj);
    var digit=this._symbolCol(colName);
    if (digit>-1) {
      if (digit==this.list.items[row].displaySymbolIndex)  { props.AppendElement(aserv.getAtom("WILL_highlightDisplaySymbol"));  }
      if (this.highlightDups) {
	var str=this.getCellText(row,colObj);
	if (!str) { return; }
	if (!this.list.isUnique(str)) {
	  //this str is used by another curr - so highlight it
	  props.AppendElement(aserv.getAtom("WILL_highlight")); 
	}
      }
    }
  };

  this.getColumnProperties = function(colid,colObj,props){};
  this.getParentIndex = function(row){return -1;};
  this.cycleHeader = function(colObj, elem) { };
  this.performAction = function(action) {
    //alert('got action '+action);
    //assume invalidate - I'm too lazy to calculate which row changed
    this.treebox.beginUpdateBatch();
    this.rowCount = this.list.items.length;
    this.treebox.endUpdateBatch();
  };
}


function WILL_toColName(colObj) {
  if (!colObj) { return undefined; } // WILL: who does this?
  var colName;
  if (typeof colObj == "string") {
    colName=colObj;
  } else { // it's a treeColumn object
    colName=colObj.id;
  }
  if (!colName) { WILL_log('ERR','invalid column'+colObj); }
  return colName;
}
