// $Id: WILL_ViewMyCurrencyOverlay.js,v 1.6 2006/01/10 23:18:06 Will Exp $

// http://kb.mozillazine.org/Setting_up_extension_development_environment

//alert('This main code is executed each time a new Firefox application window is created');
if (!window.document.designMode) { window.document.designMode="off"; } // Firefox assumes this property exists

window.addEventListener("load", WILL_initViewMyCurrency, false);
window.addEventListener("unload", WILL_window_onUnLoad, false);

// Global varibales (to this Firefox application window)
var WILL_gViewMyCurrencyGui;

function WILL_initViewMyCurrency() {
  window.removeEventListener("load", WILL_initViewMyCurrency, false);
  //  alert('WILL_initViewMyCurrency: Called on each new full Firefox application window (after GUI is ready?)\n'+
  //        'But called twice if XUL is loaded as a test window - Why?  Solved by removing the listener');

  WILL_gViewMyCurrencyGui = new WILL_ViewMyCurrencyGui();
  new WILL_ViewMyCurrency(WILL_gViewMyCurrencyGui);
}


function WILL_window_onUnLoad() {
  //alert('window-unload: Called when closing each full Firefox application window\n'+
  // 'Or on leaving (or reloading) test window xul');
  if (WILL_gViewMyCurrencyGui) { 
    WILL_gViewMyCurrencyGui.die();
  } else {
    WILL_log('ERR','There was no WILL_gViewMyCurrencyGui to die() on window unload');
  }

}


